<?php

if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');

//$lang->load('hyperportal');

$page->add_breadcrumb_item("hyperPortal Widgets",hyperPortal_admin_url('config', 'hyperportal'));

//Dejo que otros se puedan colgar de mi configuracion. Thanks hyperportal for the idea.
$plugins->run_hooks('admin_config_hyperportal_begin');

//Amount of sectors configured
$sectors=$mybb->settings["hyperportal_sectors"];


$sub_tabs['hyperportal_widgets'] = array(
	'title' => "Widgets",
	'description' => "Widgets",
	'link' => hyperPortal_admin_url('config', 'hyperportal')
);

$plugins->run_hooks('admin_config_hyperportal_start');
		
$page->output_header("hyperPortal");
$page->output_nav_tabs($sub_tabs, 'hyperportal');
	
//Traigo los widget instalados y transformo el widget_name en key para buscar mas facil

$widgets_installed=array();
$widgets_installed_resource = $db->simple_select('widgets', '*');
while ($widget_installed=$db->fetch_array($widgets_installed_resource))
		$widgets_installed[$widget_installed['widget_name']]=$widget_installed;
		

//Widgets!
$widgetscache=$cache->read("hyperPortalWidgets");

//Estoy poniendo el formulario de configuracion?
if(isset($mybb->input['config']))
{
	$codename=$mybb->input['config'];
	$form = new Form(hyperportal_admin_url('config', 'hyperportal').'&amp;action=configure&amp;widget='.urlencode($codename), 'post');
	
	//Traigo la config actual
	$widget = $db->fetch_array($db->simple_select('widgets',"*", "widget_name='$codename'"));
	
	$form_container = new FormContainer("$codename widget configuration");
	
	$form_container->output_row("Show header?", "If the header is not shown the widget can't be closed, moved or configured", $form->generate_select_box('header',array(0=>"NO",1=>"YES"), $widget['header'], array()));
	
	$form_container->output_row("Fix Widget?", "If the widget is fixed it can't be moved", $form->generate_select_box('fixed',array(0=>"NO",1=>"YES"), $widget['fixed'], array()));
	
	$form_container->output_row("Guests visible?", "Select if guests can see the widget", $form->generate_select_box('guests',array(0=>"NO",1=>"YES"), $widget['guests'], array()));
	
	echo $form->generate_hidden_field('pos',$mybb->input['pos']);
	
	$buttons[] = $form->generate_submit_button("Configure");
	

		
	$form_container->end();
	$form->output_submit_wrapper($buttons);
	$form->end();
	
}
//Si estoy mostrando la configuracion no muestra nada mas
else 
{
	
	//Si hay que configurar
	if($mybb->input['action']=="configure")
	{
		$codename=$mybb->input['widget'];
			
		
				
			//Updateo el widget de la tabla de configuracion de widgets
			
			$db->update_query('widgets',array("guests"=>$mybb->input['guests'],"header"=>$mybb->input['header'],"fixed"=>$mybb->input['fixed']), "widget_name='$codename'");

			
			$widgetscache[$mybb->input['pos']][$codename]['fixed']=$mybb->input['fixed'];
			$widgetscache[$mybb->input['pos']][$codename]['guests']=$mybb->input['guests'];
			$widgetscache[$mybb->input['pos']][$codename]['header']=$mybb->input['header'];
			
			$cache->update('hyperPortalWidgets', $widgetscache);
			
			flash_message("Widget has been succesfully configured", 'success');
			admin_redirect("index.php?module=config-hyperportal");
	}
	
	

	
	//Si hay que instalar
	if($mybb->input['install']=="install")
	{
		$codename=$mybb->input['widget'];
			
		//Reviso si no existia previamente
		if(isset($widgets_installed[$codename]))
		{
			flash_message("Widget was already installed", 'error');
			admin_redirect("index.php?module=config-hyperportal");
		}
		else 
		{
		
			require_once( MYBB_ROOT."inc/widgets/{$mybb->input['pos']}/".$codename.".php");
			
			//Ejecuto la funcion de instalacion del widget
			$installfunc = $codename."_install";
			
			$infofuc = $codename."_info";
			
			
			//Si no tiene un info no es un widget
			if(function_exists($installfunc))
				$installfunc();
			
			//Si no tiene un info no es un widget
			if(function_exists($infofunc))
				$widgetinfo=$infofunc();


			$inserts=array("widget_name"=>$codename);	
			//Veo si hay ocnfiguracion por default sobre los usuarios anonimos sobre el widget
			if(isset($widgetinfo["guests"]) && ($widgetinfo["guests"]==0 || $widgetinfo["guests"]==1))
				$inserts["guests"]=$widgetinfo["guests"];
			//Inserto el widget con la configuracion por default
			//Lo hago despues de la funcion de instalacion, porque no confio en los 
			//que escriben el widget
		
			
			$db->insert_query("widgets",$inserts);

			$widget_installed = $db->fetch_array($db->simple_select('widgets',"*", "widget_name='$codename'"));
			$widgets_installed[$codename]=$widget_installed;

			flash_message("Widget has been succesfully installed", 'success');
			if($mybb->input['action']!="activate")
				admin_redirect("index.php?module=config-hyperportal");
		}
	}
	
	//Si hay que desinstalar
	if($mybb->input['install']=="uninstall")
	{
		$codename=$mybb->input['widget'];
			
		//Reviso si no existia previamente
		if(!isset($widgets_installed[$codename]))
		{
			flash_message("Widget wasn't installed", 'error');
			admin_redirect("index.php?module=config-hyperportal");
			
		}
		else 
		{
		
			require_once( MYBB_ROOT."inc/widgets/{$mybb->input['pos']}/".$codename.".php");
			
			//Ejecuto la funcion de desinstalacion del widget
			$uninstallfunc = $codename."_uninstall";
			
			//Si no tiene un info no es un widget
			if(function_exists($uninstallfunc))
				$uninstallfunc();
				
			//Borro el widget de la tabla de configuracion de widgets
			//Lo hago despues de la funcion de desinstalacion, porque no confio en los 
			//que escriben el widget
			$widget_installed = $db->delete_query('widgets', "widget_name='$codename'");

	
			unset($widgets_installed[$codename]);
			
			//Lo borro de la cache si se encontraba activo
			for($i=1;$i<=$sectors;$i++)
				unset($widgetscache["sector$i"][$codename]);
			
			$cache->update('hyperPortalWidgets', $widgetscache);
			flash_message("Widget has been succesfully uninstalled", 'success');
			admin_redirect("index.php?module=config-hyperportal");
		}
	}
	
	
	
	
	if(!isset($widgetscache) || !is_array($widgetscache) || count($widgetscache)<=0)
	{
		
		$update=array();
		for($i=1;$i<=$sectors;$i++)
			$update["sector$i"]=array();
			
		
		$widgetscache=$update;
		
	}
	
	if($mybb->input['action']=="activate")
	{
	
		$codename=$mybb->input['widget'];
		
		require_once( MYBB_ROOT."inc/widgets/{$mybb->input['pos']}/".$codename.".php");
	
		$infofunc = $codename."_info";
		//Si no tiene un info no es un widget
		if(!function_exists($infofunc))
				{
					continue;
				}
		$widgetinfo = $infofunc();  
		
		//Ejecuto la funcion de activacion del widget
		$activatefunc = $codename."_activate";
			
		//Si no tiene un info no es un widget
		if(function_exists($activatefunc))
			$activatefunc();
		$pos=$mybb->input['pos'];
		if(!isset($widgetscache[$pos][$codename]))
		{
	
			
			$widgetscache[$mybb->input['pos']][$codename]=array("name"=>$mybb->input['widget'],"description"=>$widgetinfo[description],"title"=>$widgetinfo["name"],"fixed"=>$widgets_installed[$codename]['fixed'],"guests"=>$widgets_installed[$codename]['guests'],"header"=>$widgets_installed[$codename]['header']);
			
			$cache->update('hyperPortalWidgets', $widgetscache);
			
			$db->update_query('widgets',array("active"=>1), "widget_name='$codename'");
			
			flash_message("Widget has been succesfully activated", 'success');
			admin_redirect("index.php?module=config-hyperportal");
			
		}
		else 
		{	
			flash_message("Widget was already active", 'error');
			admin_redirect("index.php?module=config-hyperportal");
			
		}
	}
	
	if($mybb->input['action']=="deactivate")
	{
	
		//Ejecuto la funcion de desactivacion del widget
		$deactivatefunc = $codename."_deactivate";
			
		//Si no tiene un info no es un widget
		if(function_exists($deactivatefunc))
			$deactivatefunc();
		
		if((isset($widgetscache[$mybb->input['pos']][$mybb->input['widget']])))
		{
			
			unset($widgetscache[$mybb->input['pos']][$mybb->input['widget']]);
			$cache->update('hyperPortalWidgets', $widgetscache);
			$db->update_query('widgets',array("active"=>0), "widget_name='$codename'");
			flash_message("Widget has been succesfully deactivated", 'success');
			admin_redirect("index.php?module=config-hyperportal");
			
		}
		else 
		{
			flash_message("Widget {$mybb->input['widget']} wasn't active", 'error');
			admin_redirect("index.php?module=config-hyperportal");
			
		}
	}
		
	if($mybb->input['action']=="reorder")
	{


		$update=array();
			for($i=1;$i<=$sectors;$i++)
			{
				$sectorW=array();
				$update["sector$i"]=array();
				parse_str($mybb->input["sector$i".'WidgetsOrder'],$sectorW);
				$update["sector$i"]=$sectorW["widget"];
			}

			$db->update_query('usergroups',array("hyperportal_template"=>serialize($update)));
			$cache->update_usergroups();
			$mybb->usergroup['hyperportal_template']=serialize($update);
			if(isset($mybb->input['overwrite']))
			{
				for($i=1;$i<=$sectors;$i++)
				{
					$widgetConfig["sector$i"]=array();
					if(is_array($update["sector$i"]))
						foreach($update["sector$i"] as $w)
							$widgetConfig["sector$i"][$w]=array("name"=>$w,"minimized"=>0);
				}

				$db->update_query('users',array("widgets_config"=>serialize($widgetConfig)));

			}
			flash_message("Widget has been succesfully sorted", 'success');
			admin_redirect("index.php?module=config-hyperportal");
			
	}
	
	
	
		
		//$form = new Form(hyperportal_admin_url('config', 'threadfields&amp;action=inline'), 'post', 'inline');
		
		$table = new Table;
		$table->construct_header("Widget");
		$table->construct_header("Description", array('width' => '50%'));
		$table->construct_header("Install", array('width' => '10%'));
		$table->construct_header("Activation", array('width' => '10%'));
		$table->construct_header("Configuration", array('width' => '10%'));
		
		//Widgets list
		for($i=1;$i<=$sectors;$i++)
		{
		
		$files=get_widget_list("sector$i");
		$celldata = "<strong>Widgets Sector $i</strong>";
		$table->construct_cell($celldata, array('colspan' => 5, 'style' => 'padding: 2px;'));
		$table->construct_row();
		if(is_array($files) && count($files)>0)
			foreach($files as $codename)
			{
				require_once MYBB_ROOT."inc/widgets/sector$i/".$codename.".php";;
				
				$infofunc = $codename."_info";
				//Si no tiene un info no es un widget
				if(!function_exists($infofunc))
						{
							continue;
						}
				$widgetinfo = $infofunc();
				$table->construct_cell($widgetinfo[name]);
				$table->construct_cell($widgetinfo[description]);
				
				//Celda de instatalar
				if(!isset($widgets_installed[$codename]))
					$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;install=install&amp;pos=sector$i&amp;widget=".urlencode($codename).'">Install</a>');
				else 
					$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;install=uninstall&amp;pos=sector$i&amp;widget=".urlencode($codename).'">Uninstall</a>');
				

				//Celda de activar (e instalar si se desea)	
				if(!isset($widgetscache["sector$i"][$codename]))
					if(!isset($widgets_installed[$codename]))
						$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;action=activate&amp;pos=sector$i&amp;install=install&amp;widget=".urlencode($codename).'">Install / Activate</a>');
					else
						$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;action=activate&amp;pos=sector$i&amp;widget=".urlencode($codename).'"> Activate</a>');
					
				else 
					$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;action=deactivate&amp;pos=sector$i&amp;widget=".urlencode($codename).'">Desactivate</a>');
				
				//Celda de configuracion
				if(!isset($widgets_installed[$codename]))
					$table->construct_cell("");
				else 
					$table->construct_cell('<a href="'.hyperPortal_admin_url('config', 'hyperportal')."&amp;pos=sector$i&amp;config=".urlencode($codename).'">Configure</a>');
					
				
				$table->construct_row();
			}
		
		}

		$default=unserialize($mybb->usergroup['hyperportal_template']);

		$table->output("hyperPortal Widgets");
		$table=new Table;
		$table->output("Default Widgets Order");
		echo '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
			  <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js"></script>
			  <link rel="stylesheet" type="text/css" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/themes/base/jquery-ui.css"/>
<script language="javascript" type="text/javascript">jQuery.noConflict();</script>
			  ';
		$form = new Form(hyperportal_admin_url('config', 'hyperportal').'&amp;action=reorder', 'post');
		
		
		
	echo "<style>
	

	.adminListSector
	{
		width:180px;
		float:left;
		margin-left:10px;
		min-height:50px;
		background-color:#dddddd;
		margin-top:10px;
		border: 1px solid #888888;
	}
	
	</style>";
	
		echo "<center><div >";
		echo "<div style='clear:both'>Default Visible Widgets Order</div>";
		
		
		for($i=1;$i<=$sectors;$i++)
		{
			echo "<div id='sector{$i}Column' class='adminListSector$i adminListSector' >";
			if(count($default["sector$i"]))
				foreach($default["sector$i"] as $widget)
				{
					echo "<div  class='sector{$i}Widget' id='widget_$widget'  style='margin-bottom:3px;min-height:50px;background-color:#dddddd;border:2px solid #888888;'>{$widgetscache["sector$i"][$widget][title]}</div>";	
					unset($widgetscache["sector$i"][$widget]);
		
				}
			echo "</div>";
		}
		echo "<div >";

				echo "		<div style='clear:both'>Default NOT Visible Widgets</div>";
		
		for($i=1;$i<=$sectors;$i++)
		{
				
			echo "<div id='notSector{$i}Column' class='adminListSector$i  adminListSector'  >";
			if(count($widgetscache["sector$i"]))
				foreach($widgetscache["sector$i"] as $widget)
				{
					echo "<div class='notSector{$i}Widget' id='widget_$widget[name]' style='margin-bottom:3px;min-height:50px;background-color:#dddddd;border:2px solid #888888;'>$widget[title]</div>";	
				}
			echo "</div>
			
			<input type='hidden' name='sector{$i}WidgetsOrder' id='sector{$i}WidgetsOrder'/>
			";

		}
		echo "</div>		
		
		

		";
	echo "
	<div style='clear:both'/>
	<strong>";
	echo $form->generate_check_box('overwrite',false,"Overwrite all");
	echo "</strong>If this ckecbox is activated the configuration for all users will be overwritten. It is only recommended to use if you are installing the portal or if you want to reset it.";

	$buttons[] = $form->generate_submit_button("Change order");
	$form->output_submit_wrapper($buttons);
	echo "</div></center>";
	$form->end();

echo "

<style>
.dragBorder
{
	border: 1px dashed #061927; 
}
</style>
<script>

    jQuery(function() {
";

	for($i=1;$i<=$sectors;$i++)
	{
	  echo  "
	  		jQuery( '#sector{$i}Column' ).sortable({
		   			placeholder: 'dragBorder',
		   			connectWith:'#notSector{$i}Column',
		   			forcePlaceholderSize:true,
		   			tolerance: '30%',
		   			update: function( event, ui ) {
		   					var order = jQuery(this).sortable('serialize');
							jQuery('#sector{$i}WidgetsOrder').val(order);
		   			}
		         });
		       
				var order = jQuery('#sector{$i}Column').sortable('serialize');
				
				jQuery('#sector{$i}WidgetsOrder').val(order);
		
				jQuery( '#notSector{$i}Column' ).sortable({
		          	accept: '.sector{$i}Widget',
		            connectWith:'#sector{$i}Column',
		            placeholder: 'dragBorder',
		   			forcePlaceholderSize:true,
		   			tolerance: '30%',
		   			update: function( event, ui ) {
		   					var order = jQuery('#sector{$i}Column').sortable('serialize');
							jQuery('#sector{$i}WidgetsOrder').val(order);
							ui.item.css('margin-left',0);
		   			}
		        });";
	}	       
        
        
  echo "
       
           
    });
</script>";
		

}

$page->output_footer();