<?php

/**
 * MyBB 1.6
 * Widget de prueba
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}

function googleAd1_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	global $lang;
	
	$lang->load("hyperportal");
	
	return array(
		"name"			=> "Prueba",
		"description"	=> "",
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
}
	
function googleAd1_install()
{
	global $db,$cache;
	//Create the admin settings
	$query = $db->query("SELECT disporder FROM ".TABLE_PREFIX."settinggroups ORDER BY `disporder` DESC LIMIT 1");
	$disporder = $db->fetch_field($query, 'disporder')+1;

	$setting_group = array(
	'name' 			=>	'wgoogleAd1_settings',
	'title' 		=>	'GoogleAd1 Widget',
	'description' 	=>	'Settings to configure your HyperPortal GoogleAd1 Widget',
	'disporder' 	=>	intval($disporder),
	'isdefault' 	=>	'no'
	);
	$db->insert_query('settinggroups', $setting_group);
	$gid = $db->insert_id();

	$settings = array(
	'wgoogleAd1_client' 		=> array(
	'title' 			=> 'GoogleAd Client Id',
	'description' 		=> 'Your client Id',
	'optionscode'		=> 'text',
	'value'				=> ''),
	'wgoogleAd1_slot' 		=> array(
	'title' 			=> 'GoogleAd Slot',
	'description' 		=> 'This ads slot',
	'optionscode'		=> 'text',
	'value'				=> ''),
	'wgoogleAd1_width' 	=> array(
	'title' 			=> 'Width',
	'description' 		=> 'This ads width',
	'optionscode'		=> 'text',
	'value'				=> '728'),
	'wgoogleAd1_height' 	=> array(
	'title' 			=> 'Height',
	'description' 		=> 'This ads height',
	'optionscode'		=> 'text',
	'value'				=> '90')
	);

	$x = 1;
	foreach($settings as $name => $setting)
	{
		$insert_settings = array(
		'name' => $db->escape_string($prefix.$name),
		'title' => $db->escape_string($setting['title']),
		'description' => $db->escape_string($setting['description']),
		'optionscode' => $db->escape_string($setting['optionscode']),
		'value' => $db->escape_string($setting['value']),
		'disporder' => $x,
		'gid' => $gid,
		'isdefault' => 0
		);
		$db->insert_query('settings', $insert_settings);
		$x++;
	}

	rebuild_settings();

}

function googleAd1_uninstall()
{
		global $db,$cache;
	
	// Remove settings
	$result = $db->simple_select('settinggroups', 'gid', "name = 'wgoogleAd1_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);

	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}

}

	function googleAd1()
	{

		global $mybb;

	$googleAd1="
<div style='text-align:center; clear:both'>
<span>
<script type='text/javascript'><!--
google_ad_client = '{$mybb->settings['wgoogleAd1_client']}';
/* BNR, Varios, Inferior */
google_ad_slot = '{$mybb->settings['wgoogleAd1_slot']}';
google_ad_width = {$mybb->settings['wgoogleAd1_width']};
google_ad_height = {$mybb->settings['wgoogleAd1_height']};
//-->
</script>
<script type='text/javascript'
src='http://pagead2.googlesyndication.com/pagead/show_ads.js'>
</script>
</span></div>";
	return $googleAd1;
	}

?>