<?php

/**
 * MyBB 1.6
 * Estadisticas
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}
function stats_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	global $lang;
	
	$lang->load("hyperportal",true);
	
	
	return array(
		"name"			=> $lang->h_info_stats_title,
		"description"	=> $lang->h_info_stats_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
}
	
	function stats()
	{
		global $mybb,$cache,$templates,$lang;
			// Get Forum Statistics
			
		$lang->load("portal");		
		
		$stats = $cache->read("stats");
		$stats['numthreads'] = my_number_format($stats['numthreads']);
		$stats['numposts'] = my_number_format($stats['numposts']);
		$stats['numusers'] = my_number_format($stats['numusers']);
		if(!$stats['lastusername'])
		{
			$newestmember = "<strong>" . $lang->no_one . "</strong>";
		}
		else
		{
			$newestmember = build_profile_link($stats['lastusername'], $stats['lastuid']);
		}
		eval("\$stats = \"".$templates->get("widget_portal_stats")."\";");

		return $stats;
	}
	
	function stats_install()
	{
		global $db;
		 //Now we create the default template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $template= array( 
    					"sid"		  => -1,
                        "title"       => "widget_portal_stats",
			     		"template"    => '<span class="smalltext">
<strong>&raquo; </strong>{$lang->num_members} {$stats[numusers]}<br />
<strong>&raquo; </strong>{$lang->latest_member} {$newestmember}<br />
<strong>&raquo; </strong>{$lang->num_threads} {$stats[numthreads]}<br />
<strong>&raquo; </strong>{$lang->num_posts} {$stats[numposts]}
<br /><br /><a href="{$mybb->settings[bburl]}/stats.php">{$lang->full_stats}</a>
</span>
');
	 $db->insert_query("templates", $template);	
	}
	
	function stats_uninstall()
	{
		global $db;
	    //Now we delete the template
	    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	    $db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='widget_portal_stats'");
	}

?>