<?php

/**
 * MyBB 1.6
 * wtp
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}
function wtp_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	global $lang;
	$lang->load("hyperportal",true);
	
	return array(
		"name"			=> $lang->h_info_wtp_title,
		"description"	=> $lang->h_info_wtp_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz, based on Index Top Posters by Pars from MyBBIran.com",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
}
	
	function wtp()
	{
		global $db,$mybb;
	
		//get today
        $todaytime = TIME_NOW - 86400;
        $query = $db->query("SELECT u.uid,u.username,u.displaygroup,u.usergroup,u.avatar,COUNT(*) AS ptoday FROM ".TABLE_PREFIX."posts p LEFT JOIN ".TABLE_PREFIX."users u ON (p.uid=u.uid) LEFT JOIN ".TABLE_PREFIX."forums f ON (p.fid=f.fid) WHERE f.usepostcounts = 1 AND u.usergroup NOT IN (1,5,7,11) AND p.dateline > $todaytime GROUP BY p.uid ORDER BY ptoday DESC LIMIT 0,4");
        $today_wtp = '<table border="0" cellspacing="0" cellpadding="0" width="100%">';
        while($user = $db->fetch_array($query))
        {
            $posts = $user['ptoday'];
            if($user['avatar'] != '')
            {
                $user['avatar'] = $user['avatar'];
            }
            else
            {
                $user['avatar'] = "./images/default_avatar.gif";
            }
            $user['username'] = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
            $userlink = build_profile_link($user['username'], $user['uid']);
  //              $today_wtp .= '<tr><td align="left">'.$userlink.'</td><td align="right">'.$posts.'</td></tr>';
            $ava = '<img src="'.$user['avatar'].'" 	width="24px" height="24px">';
            $today_wtp .= '<tr><td 	width="30px">'.$ava.'</td><td align="left">'.$userlink.'</td><td >'.$posts.'</td></tr>';
        }
        $today_wtp .= '</table>';

        $query = $db->query("SELECT * FROM ".TABLE_PREFIX."users u WHERE u.usergroup NOT IN (1,5,7,11) ORDER BY postnum DESC LIMIT 0,4");
        $top_wtp = '<table border="0" cellspacing="0" cellpadding="0" width="100%">';
        while($user = $db->fetch_array($query))
        {
            $posts = $user['postnum'];
            if($user['avatar'] != '')
            {
                $user['avatar'] = $user['avatar'];
            }
            else
            {
                $user['avatar'] = "./images/default_avatar.gif";
            }

            $user['username'] = format_name($user['username'], $user['usergroup'], $user['displaygroup']);
            $userlink = build_profile_link($user['username'], $user['uid']);
//                $top_wtp .= '<tr><td align="left">'.$userlink.'</td><td align="right">'.$posts.'</td></tr>';
            $ava = '<img src="'.$user['avatar'].'" 	width="24px" height="24px">';
            $top_wtp .= '<tr><td 	width="30px">'.$ava.'</td><td align="left">'.$userlink.'</td><td >'.$posts.'</td></tr>';
        }
        $top_wtp .= '</table>';
       return  "<table width='100%'><tr><td><strong>Hoy</strong></td><td><strong>Historico</strong></td></tr><tr><td>$today_wtp</td><td>$top_wtp</td></tr></table>";
	
	}

?>